/*
 *	pme001.c
 *
 *	P/ECE Linux device driver
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Sun Dec 30 22:10:02 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#include <linux/kernel.h>	/* ͥAPIȤΤɬ */
#include <linux/malloc.h>	/* kmalloc/kfreeȤΤɬ */
#include <linux/module.h>	/* ⥸塼벽뤿ɬ */
#include <linux/init.h>		/* ⥸塼벽뤿ɬ */
#include <linux/usb.h>		/* USB APIȤΤɬ */
#include <asm/uaccess.h>	/* access_okʤɤȤΤɬ */
#include "pme001.h"

//#define DEBUG

#define PME001_VENDOR_ID	0x0e19	/* P/ECEUSBID */
#define PME001_PRODUCT_ID	0x1000	/* (Ʊ) */
#define PME001_MINOR_BASE	128	/* MAJOR=180(USB),MINOR=128144 */
#define PME001_MINOR_SIZE	16	/* 饯ǥХȤʤޤ */

#define TIMEOUT			(HZ * 1)	/* 1åॢ */
/* usb_bulk_msg(...,MAX_SCHEDULE_TIMEOUT)ȤȡCtrl+Cʤ */
/*#define TIMEOUT		MAX_SCHEDULE_TIMEOUT*/

/* NOTE:
 * opencloseδ֤˵郎곰줿ͤơȲ(PME001.refcnt)ߤޤ
 * ºݤ˻Ȥopen֤ǵ곰ȡrelease->disconnectνǸƤФ褦Ǥ
 * äơե륷ƥؿƤФ줿ȤPME001.dev=NULLˤʤäƤ뤳ȤϤꤨ
 * ޤȲδפȤȤˤʤޤ
 * ץץϤΤ褦ˤʤäƤΤǡǰΤᤳΤޤޤˤƤޤ
 * ʤȤ⡢̵ϤǤ
 */

/* P/ECE뤿ι¤ΤǤ
 */
typedef struct _PME001 {
	struct usb_device* dev;		/* USB¤ */
	int minor;			/* ޥʡֹ(0PME001_MINOR_SIZE-1) */
	int refcnt;			/* Ȳ */
	/* bulk-in */
	int bulk_in_endpoint;		/* Х륯INɥݥȥɥ쥹 */
	int bulk_in_buffer_size;	/* Х륯INХåե */
	void* bulk_in_buffer;		/* Х륯INХåե */
	/* bulk-out */
	int bulk_out_endpoint;		/* Х륯OUTɥݥȥɥ쥹 */
	int bulk_out_buffer_size;	/* Х륯OUTХåե */
	void* bulk_out_buffer;		/* Х륯OUTХåե */
} PME001;
PME001* pme001_table[PME001_MINOR_SIZE];/* ƥޥʡֹбP/ECE */

/* ⥸塼Ϣ */
int  pme001_init();
void pme001_exit();
/* USBϢ */
void* pme001_probe(struct usb_device* dev, unsigned int ifnum, const struct usb_device_id* id);
void pme001_disconnect(struct usb_device* dev, void* ptr);
void pme001_free(PME001* pme001);
int usb_read(PME001* pme001, void* buffer, int count);
int usb_write(PME001* pme001, const void* buffer, int count);
/* ե륷ƥϢ */
int pme001_open(struct inode* inode, struct file* file);
int pme001_release(struct inode* inode, struct file* file);
ssize_t pme001_read(struct file* file, char* buffer, size_t count, loff_t* ppos);
ssize_t pme001_write(struct file* file, const char* buffer, size_t count, loff_t* ppos);
int pme001_ioctl(struct inode* inode, struct file* file, unsigned int cmd, unsigned long arg);
int ioc_getversion(PME001* pme001, PME001SYSTEMINFO* psi);
int ioc_exec(PME001* pme001, unsigned long adrs);
int ioc_ucread(PME001* pme001, void* ptr, int len);
int ioc_ucwrite(PME001* pme001, const void* ptr, int len);
int ioc_ucgetstat(PME001* pme001, PME001USBCOMS* pucs);
int ioc_ucopen(PME001* pme001, PME001USBCOMS* pucs);
int ioc_ucclose(PME001* pme001);

/* ⥸塼ν/˸ƤӽФߤؿޡޤ */
module_init(pme001_init);
module_exit(pme001_exit);

/* ΥǥХɥ饤ФݡȤUSBID */
struct usb_device_id pme001_id_table[] = {
	{ USB_DEVICE(PME001_VENDOR_ID, PME001_PRODUCT_ID) }, /* P/ECE */
	{ } /* ü */
};

/* ե륷ƥफƤӽФؿΥơ֥ */
struct file_operations pme001_fops = {
#ifndef DEBUG
	owner:		THIS_MODULE,	/* * ƤСͥ뤬ɥ饤Фä
					 *   openMOD_INC_USE_COUNT,closeMOD_DEC_USE_COUNT
					 *   ƤǤ褦ʤΤǡ֤ʤޤ
					 * * ⥸塼λȲĤäޤޥ顼
					 *   ⥸塼뤬ɤǤʤʤΤǡ
					 *   Ȳ0˰ݻ뤿ˡȯޤ
					 */
#endif /*DEBUG*/
	open:		pme001_open,	/* open˸ƤФޤ */
	release:	pme001_release,	/* close˸ƤФޤ */
	read:		pme001_read,	/* read˸ƤФޤ */
	write:		pme001_write,	/* write˸ƤФޤ */
	ioctl:		pme001_ioctl,	/* ioctl˸ƤФޤ */
};

/* USBɥ饤Ф°򼨤縵Υơ֥ */
struct usb_driver pme001_driver = {
	name:		"pme001",		/* ɥ饤̾ */
	id_table:	pme001_id_table,		/* USBIDơ֥ */
	probe:		pme001_probe,		/* ջ˸ƤФޤ */
	disconnect:	pme001_disconnect,	/* 賰˸ƤФޤ */
	fops:		&pme001_fops,		/* եؿơ֥ */
	minor:		PME001_MINOR_BASE,	/* 16ĤΥޥʡֹΥ١ */
};

/*****************************************************************************
 *	pme001_init
 *****************************************************************************/

/* ⥸塼ɤȤˡ٤ƤФޤ
 */
int
pme001_init()
{
	/* USBɥ饤ФϿޤ */
	usb_register(&pme001_driver);

	return 0; /*  */
}

/*****************************************************************************
 *	pme001_exit
 *****************************************************************************/

/* ⥸塼򥢥ɤȤˡ٤ƤФޤ
 */
void
pme001_exit()
{
	/* USBɥ饤ФϿޤ */
	usb_deregister(&pme001_driver);
}

/*****************************************************************************
 *	pme001_probe
 *****************************************************************************/

/* 郎³줿ȤˡUSBɥ饤ФФƸƤФޤ
 * Υɥ饤ФݡȤUSBä顢Ͽޤ
 */
void*
pme001_probe(struct usb_device* dev, unsigned int ifnum, const struct usb_device_id* id)
{
	int i;
	PME001* pme001;
	struct usb_interface_descriptor* interface;
	struct usb_endpoint_descriptor* endpoint;

//info(__FUNCTION__);

	pme001 = NULL; /* 顼ΤˡNULLȤƤ */

	/* /usr/src/linux/driver/usb/usb.cɤ¤ꡢ
	 * pme001_driver.id_tableUSBIDꤷƤС
	 * ʳεˤĤpme001_probeƤФ뤳ȤϤʤϤǤ
	 * ŤΥɥ饤ФǤϡɥ饤°ơ֥USB IDꤻ
	 * ǤդΥǥХդ줿Ȥ̵probeƤӽФ
	 * ɥ饤ФݡȤ뵡狼ɤprobeȽǤƤ褦Ǥ
	 * Υɥ饤ФϿȸΤǡP/ECEʳεˤĤ
	 * pme001_probeƤФ뤳ȤϤʤϤʤΤǤ
	 * ǰΤḡ뤳Ȥˤޤ
	 */
	if(dev->descriptor.idVendor != PME001_VENDOR_ID ||
	   dev->descriptor.idProduct != PME001_PRODUCT_ID) goto EHAND;

	/* 󥿡եǥץƤޤ */
	interface = &dev->actconfig->interface[ifnum].altsetting[0];

	/* P/ECEΰݤޤ */
	pme001 = (PME001*)kmalloc(sizeof(PME001), GFP_KERNEL);
	if(pme001 == NULL) {
		err(__FUNCTION__ " kmalloc(pme001) failed");
		goto EHAND;
	}
	memset(pme001, 0, sizeof(PME001)); /* 顼Τˡꥢ */

	/* ǥХǥץǼޤ */
	pme001->dev = dev;

	/* Х륯INɥݥȤõޤ */
	for(i = 0; i < interface->bNumEndpoints; i++) {
		endpoint = &interface->endpoint[i];
		if((endpoint->bEndpointAddress & 0x80) && /* bit7=0:OUT/1:IN */
		   (endpoint->bmAttributes & 3) == 2) {   /* 2:Х륯 */
			break;
		}
	}
	if(i == interface->bNumEndpoints) {
		err(__FUNCTION__ " bulk-in not found");
		goto EHAND;
	}
	/* ɥݥȥɥ쥹Ǽޤ */
	pme001->bulk_in_endpoint = endpoint->bEndpointAddress;
	/* ڥɥƱ礭ΥХåեݤޤ */
	pme001->bulk_in_buffer_size = endpoint->wMaxPacketSize;
	pme001->bulk_in_buffer = kmalloc(endpoint->wMaxPacketSize, GFP_KERNEL);
	if(pme001->bulk_in_buffer == NULL) {
		err(__FUNCTION__ " kmalloc(bulk_in_buffer) failed");
		goto EHAND;
	}

	/* Х륯OUTɥݥȤõޤ */
	for(i = 0; i < interface->bNumEndpoints; i++) {
		endpoint = &interface->endpoint[i];
		if(!(endpoint->bEndpointAddress & 0x80) && /* bit7=0:OUT/1:IN */
		    (endpoint->bmAttributes & 3) == 2) {   /* 2:Х륯 */
			break;
		}
	}
	if(i == interface->bNumEndpoints) {
		err(__FUNCTION__ " bulk-out not found");
		goto EHAND;
	}
	/* ɥݥȥɥ쥹Ǽޤ */
	pme001->bulk_out_endpoint = endpoint->bEndpointAddress;
	/* ڥɥƱ礭ΥХåեݤޤ */
	pme001->bulk_out_buffer_size = endpoint->wMaxPacketSize;
	pme001->bulk_out_buffer = kmalloc(endpoint->wMaxPacketSize, GFP_KERNEL);
	if(pme001->bulk_out_buffer == NULL) {
		err(__FUNCTION__ " kmalloc(bulk_out_buffer) failed");
		goto EHAND;
	}

	/* ޥʡֹζ֤˳Ǽޤ */
	for(i = 0; i < PME001_MINOR_SIZE; i++) {
		if(pme001_table[i] == NULL) break;
	}
	if(i == PME001_MINOR_SIZE) {
		err(__FUNCTION__ " too many minors");
		goto EHAND;
	}
	pme001->minor = i;
	pme001_table[i] = pme001;

	/* Ȳ1Ȥޤ */
	pme001->refcnt++;

	return pme001; /* <>NULL: */

EHAND:
	pme001_free(pme001);
	return NULL; /* <>NULL: */
}

/*****************************************************************************
 *	pme001_disconnect
 *****************************************************************************/

/* 郎곰줿Ȥˡε椷Ƥɥ饤ФФƸƤФޤ
 */
void
pme001_disconnect(struct usb_device* dev, void* ptr)
{
	PME001* pme001;

//info(__FUNCTION__);

	pme001 = (PME001*)ptr;

	/* ǥХǥץ򥯥ꥢޤ */
	pme001->dev = NULL;

	/* Ȳ򸺤餷ơ0ˤʤäޤ */
	if(--pme001->refcnt == 0) pme001_free(pme001);
}

/*****************************************************************************
 *	pme001_free
 *****************************************************************************/

/* P/ECE¤Τޤ
 */
void
pme001_free(PME001* pme001)
{
	/* P/ECE¤ΤƤƤʤС⤷ޤ */
	if(pme001 == NULL) return;

	/* ޥʡơ֥ϿƤ顢Ͽޤ */
	if(pme001_table[pme001->minor] == pme001) pme001_table[pme001->minor] = NULL;

	/* Х륯žOUTХåեƤƤ顢ޤ */
	if(pme001->bulk_out_buffer != NULL) kfree(pme001->bulk_out_buffer);

	/* Х륯žINХåեƤƤ顢ޤ */
	if(pme001->bulk_in_buffer != NULL) kfree(pme001->bulk_in_buffer);

	/* P/ECE¤Τޤ */
	kfree(pme001);
}

/*****************************************************************************
 *	usb_read
 *****************************************************************************/

int
usb_read(PME001* pme001, void* buffer, int count)
{
	int retval;

	/* ˥ǥХ곰Ƥ顢顼֤ޤ */
	if(pme001->dev == NULL) return -ENODEV;

	/* ׵᥵ڥɥڤͤޤ */
	if(count > pme001->bulk_in_buffer_size) count = pme001->bulk_in_buffer_size;

	/* ׵ȯԤޤ */
	retval = usb_bulk_msg(pme001->dev,
		usb_rcvbulkpipe(pme001->dev, pme001->bulk_in_endpoint),
		pme001->bulk_in_buffer, count, &count, TIMEOUT);
	if(retval != 0) {
		err(__FUNCTION__ " usb_bulk_msg(in) failed");
		return retval; /* <0: */
	}

	/* ǡХåե˥ԡޤ */
	memcpy(buffer, pme001->bulk_in_buffer, count);

	return count;
}

/*****************************************************************************
 *	usb_write
 *****************************************************************************/

int
usb_write(PME001* pme001, const void* buffer, int count)
{
	int retval;

	/* ˥ǥХ곰Ƥ顢顼֤ޤ */
	if(pme001->dev == NULL) return -ENODEV;

	/* ׵᥵ڥɥڤͤޤ */
	if(count > pme001->bulk_out_buffer_size) count = pme001->bulk_out_buffer_size;

	/* ǡХåե˥ԡޤ */
	memcpy(pme001->bulk_out_buffer, buffer, count);

	/* ׵ȯԤޤ */
	retval = usb_bulk_msg(pme001->dev,
		usb_sndbulkpipe(pme001->dev, pme001->bulk_out_endpoint),
		pme001->bulk_out_buffer, count, &count, TIMEOUT);
	if(retval != 0) {
		err(__FUNCTION__ " usb_bulk_msg(out) failed");
		return retval; /* <0: */
	}

	return count;
}

/*****************************************************************************
 *	pme001_open
 *****************************************************************************/

/* ǥХե(/dev/usb/pme001015)򳫤Ȥ˸ƤФޤ
 */
int
pme001_open(struct inode* inode, struct file* file)
{
	int i;
	PME001* pme001;

//info(__FUNCTION__);

	/* iΡɤΥޥʡֹбP/ECEޤ */
	i = MINOR(inode->i_rdev) - PME001_MINOR_BASE;
	if(i < 0 || PME001_MINOR_SIZE <= i) return -ENODEV; /* <0: */
	pme001 = pme001_table[i];
	if(pme001 == NULL) return -ENODEV; /* <0: */

	/* θνơե¤Τ˳ǼƤޤ */
	file->private_data = pme001;

	/* ȥȤ䤷ޤ */
	pme001->refcnt++;

	return 0; /* 0: */
}

/*****************************************************************************
 *	pme001_release
 *****************************************************************************/

/* ǥХեĤȤ˸ƤФޤ */
int
pme001_release(struct inode* inode, struct file* file)
{
	PME001* pme001;

//info(__FUNCTION__);

	/* 줿եǤ뤳Ȥǧޤ
	 * ɬפʤȻפɡץ뤬äƤΤǤäƤߤޤ
	 */
	pme001 = (PME001*)file->private_data;
	if(pme001 == NULL) return -ENODEV; /* <0: */

	/* Ȳ򸺤餷ơ0ˤʤäޤ */
	if(--pme001->refcnt == 0) pme001_free(pme001);

	return 0; /* 0: */
}

/*****************************************************************************
 *	pme001_read
 *****************************************************************************/

int
pme001_read(struct file* file, char* buffer, size_t count, loff_t* ppos)
{
	int retval, local_open;
	PME001* pme001;
	PME001USBCOMS ucs;

//info(__FUNCTION__);

	/* ץ˳ǼP/ECE¤ΤФޤ */
	pme001 = (PME001*)file->private_data;
	if(pme001 == NULL) return -ENODEV; /* <0: */

	/* Хåե˽񤱤뤳Ȥǧޤ */
	if(!access_ok(VERIFY_WRITE, buffer, count)) return -EFAULT; /* <0: */

	/* P/ECE֤̿ޤ */
	retval = ioc_ucgetstat(pme001, &ucs);
	if(retval != 0) return retval;

	/* P/ECE¦openƤʤСopenޤԤޤ */
	while(!ucs.pistat) {
		retval = ioc_ucgetstat(pme001, &ucs);
		if(retval != 0) return retval;
		schedule();
		if(signal_pending(current)) return -EINTR;
	}

	/* PC¦openƤʤСŪopenޤ */
	if(!ucs.mystat) {
		retval = ioc_ucopen(pme001, &ucs);
		if(retval != 0) return retval;
		local_open = 1;
	} else {
		local_open = 0;
	}

	/* P/ECE¦׵᤬ȯԤƤʤСȯԤޤԤޤ */
	while(!(ucs.txstat & UCS_TXWAIT)) {
		retval = ioc_ucgetstat(pme001, &ucs);
		if(retval != 0) return retval;
		schedule();
		if(signal_pending(current)) return -EINTR;
	}

	/* P/ECE׵᥵PCμХåեäƤ顢
	 * 顼Ȥޤ(ʤ궯ʻͤǤ...^^;)
	 */
	if(ucs.txlen != count) return -EINVAL;

	/* ǡޤ */
	retval = ioc_ucread(pme001, buffer, count);
	if(retval != 0) return retval;

	/* USBϥѥåȤݾ㤵ƤϤʤΤǡ
	 * P/ECE¦Υǡλ֤ԤɬפϤʤȻפޤ
	 */

	/* Ūopenϡcloseޤ */
	if(local_open) {
		retval = ioc_ucclose(pme001);
		if(retval != 0) return retval;
	}

	/* TODO: openΥ顼ȴˡcloseƤʤ */

	return count;
}

/*****************************************************************************
 *	pme001_write
 *****************************************************************************/

int
pme001_write(struct file* file, const char* buffer, size_t count, loff_t* ppos)
{
	int retval, local_open;
	PME001* pme001;
	PME001USBCOMS ucs;

//info(__FUNCTION__);

	/* ץ˳ǼP/ECE¤ΤФޤ */
	pme001 = (PME001*)file->private_data;
	if(pme001 == NULL) return -ENODEV; /* <0: */

	/* Хåեɤ뤳Ȥǧޤ */
	if(!access_ok(VERIFY_READ, buffer, count)) return -EFAULT; /* <0: */

	/* P/ECE֤̿ޤ */
	retval = ioc_ucgetstat(pme001, &ucs);
	if(retval != 0) return retval;

	/* P/ECE¦openƤʤСopenޤԤޤ */
	while(!ucs.pistat) {
		retval = ioc_ucgetstat(pme001, &ucs);
		if(retval != 0) return retval;
		schedule();
		if(signal_pending(current)) return -EINTR;
	}

	/* PC¦openƤʤСŪopenޤ */
	if(!ucs.mystat) {
		retval = ioc_ucopen(pme001, &ucs);
		if(retval != 0) return retval;
		local_open = 1;
	} else {
		local_open = 0;
	}

	/* P/ECE¦μ׵᤬ȯԤƤʤСȯԤޤԤޤ */
	while(!(ucs.rxstat & UCS_RXWAIT)) {
		retval = ioc_ucgetstat(pme001, &ucs);
		if(retval != 0) return retval;
		schedule();
		if(signal_pending(current)) return -EINTR;
	}

	/* P/ECEμ׵᥵PCХåեäƤ顢
	 * 顼Ȥޤ(ʤ궯ʻͤǤ...^^;)
	 */
	if(ucs.rxlen != count) return -EINVAL;

	/* ǡޤ */
	retval = ioc_ucwrite(pme001, buffer, count);
	if(retval != 0) return retval;

	/* USBϥѥåȤݾ㤵ƤϤʤΤǡ
	 * P/ECE¦Υǡλ֤ԤɬפϤʤȻפޤ
	 */

	/* Ūopenϡcloseޤ */
	if(local_open) {
		retval = ioc_ucclose(pme001);
		if(retval != 0) return retval;
	}

	/* TODO: openΥ顼ȴˡcloseƤʤ */

	return count;
}

/*****************************************************************************
 *	pme001_ioctl
 *****************************************************************************/

int
pme001_ioctl(struct inode* inode, struct file* file, unsigned int cmd, unsigned long arg)
{
	PME001* pme001;
	PME001UCREAD* ucr;
	PME001UCWRITE* ucw;

	/* ץ˳ǼP/ECE¤ΤФޤ */
	pme001 = (PME001*)file->private_data;
	if(pme001 == NULL) return -ENODEV; /* <0: */

	/* 餫åԤäƤޤ */
	if(_IOC_TYPE(cmd) != PME001_IOC_MAGIC) return -EINVAL;
	if(_IOC_NR(cmd) > PME001_IOC_MAXNR) return -EINVAL;
	if((_IOC_DIR(cmd) & _IOC_READ) && /* ץꥱ:Read<-Write:ɥ饤 */
	   !access_ok(VERIFY_WRITE, (void*)arg, _IOC_SIZE(cmd))) return -EFAULT; 
	if((_IOC_DIR(cmd) & _IOC_WRITE) && /* ץꥱ:Write->Read:ɥ饤 */
	   !access_ok(VERIFY_READ, (void*)arg, _IOC_SIZE(cmd))) return -EFAULT; 

	switch(cmd) {
	case PME001_IOC_GETVERSION:
		return ioc_getversion(pme001, (PME001SYSTEMINFO*)arg);
		return 0;
	case PME001_IOC_EXEC:
		return ioc_exec(pme001, arg);
	case PME001_IOC_READMEM:
	case PME001_IOC_WRITEMEM:
		/* TODO: ̤ */
		return -EINVAL;
	case PME001_IOC_UCREAD:
		ucr = (PME001UCREAD*)arg;
		if(!access_ok(VERIFY_WRITE/*!*/, ucr->ptr, ucr->len)) return -EFAULT;
		return ioc_ucread(pme001, ucr->ptr, ucr->len);
	case PME001_IOC_UCWRITE:
		ucw = (PME001UCWRITE*)arg;
		if(!access_ok(VERIFY_READ/*!*/, ucw->ptr, ucw->len)) return -EFAULT;
		return ioc_ucwrite(pme001, ucr->ptr, ucr->len);
	case PME001_IOC_UCGETSTAT:
		return ioc_ucgetstat(pme001, (PME001USBCOMS*)arg);
	case PME001_IOC_UCOPEN:
		return ioc_ucopen(pme001, (PME001USBCOMS*)arg);
	case PME001_IOC_UCCLOSE:
		return ioc_ucclose(pme001);
	}

	return -EINVAL;
}

/*****************************************************************************
 *	ioc_getversion
 *****************************************************************************/

int
ioc_getversion(PME001* pme001, PME001SYSTEMINFO* psi)
{
	int retval;
	char buf[64];

	buf[0] = 0;
	buf[1] = sizeof(PME001SYSTEMINFO);
	retval = usb_write(pme001, buf, 2);
	if(retval < 0) return retval;
	if(retval != 2) return -EIO;

	retval = usb_read(pme001, psi, sizeof(PME001SYSTEMINFO));
	if(retval < 0) return retval;
	if(retval != sizeof(PME001SYSTEMINFO)) return -EIO;

	return 0;
}

/*****************************************************************************
 *	ioc_exec
 *****************************************************************************/

int
ioc_exec(PME001* pme001, unsigned long adrs)
{
	int retval;
	char buf[64];

	buf[0] = 1;
	memcpy(&buf[1], &adrs, sizeof(unsigned long));
	retval = usb_write(pme001,  buf, 5);
	if(retval < 0) return retval;
	if(retval != 5) return -EIO;

	return 0;
}

/*****************************************************************************
 *	ioc_ucread
 *****************************************************************************/

int
ioc_ucread(PME001* pme001, void* ptr, int len)
{
	int retval, n;
	char buf[64];

	buf[0] = 10;
	retval = usb_write(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	n = 0;
	while(n < len) {
		retval = usb_read(pme001, (char*)ptr + n, len - n);
		if(retval < 0) return retval;
		n += retval;
	}

	return 0;
}

/*****************************************************************************
 *	ioc_ucwrite
 *****************************************************************************/

int
ioc_ucwrite(PME001* pme001, const void* ptr, int len)
{
	int retval, n;
	char buf[64];

	buf[0] = 11;
	retval = usb_write(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	n = 0;
	while(n < len) {
		retval = usb_write(pme001, (char*)ptr + n, len - n);
		if(retval < 0) return retval;
		n += retval;
	}

	return 0;
}

/*****************************************************************************
 *	ioc_ucgetstat
 *****************************************************************************/

int
ioc_ucgetstat(PME001* pme001, PME001USBCOMS* pucs)
{
	int retval;
	char buf[64];

	buf[0] = 12;
	retval = usb_write(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	retval = usb_read(pme001, pucs, 12/*ȾΤ!*/);
	if(retval < 0) return retval;
	if(retval != 12/*ȾΤ!*/) return -EIO;

	return 0;
}

/*****************************************************************************
 *	ioc_ucopen
 *****************************************************************************/

int
ioc_ucopen(PME001* pme001, PME001USBCOMS* pucs)
{
	int retval;
	char buf[64];

	buf[0] = 13;
	retval = usb_write(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	retval = usb_read(pme001, pucs, sizeof(PME001USBCOMS));
	if(retval < 0) return retval;
	if(retval != sizeof(PME001USBCOMS)) return -EIO;

	return 0;
}

/*****************************************************************************
 *	ioc_ucclose
 *****************************************************************************/

int
ioc_ucclose(PME001* pme001)
{
	int retval;
	char buf[64];

	buf[0] = 14;
	retval = usb_write(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	retval = usb_read(pme001, buf, 1);
	if(retval < 0) return retval;
	if(retval != 1) return -EIO;

	return 0;
}

